from typing import List
from .twiz_state_manager import TwizStateManager


class UserState:
    state_manager: TwizStateManager

    def __init__(self, state_manager: TwizStateManager):
        self.state_manager = state_manager


    """
    ### USER INFO ###
    """
    @property
    def conversation_id(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('conversation_id', None)

    def set_conversation_id(self, conversation_id: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['conversationId'] = conversation_id
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def avoid_restrictions(self) -> List:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('avoid_restrictions', None)

    def set_avoid_restrictions(self, avoid_restrictions: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['avoid_restrictions'] = avoid_restrictions
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def enforce_restrictions(self) -> List:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('enforce_restrictions', None)

    def set_enforce_restrictions(self, enforce_restrictions: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['enforce_restrictions'] = enforce_restrictions
        return self.state_manager.write_user_attributes(_user_attributes)


    """
    ### CURRENT REQUEST ###
    """
    @property
    def data_source(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('data_source', None)

    def set_data_source(self, data_source: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['data_source'] = data_source
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def requested_task(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('requested_task', None)

    def set_requested_task(self, requested_task: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['requested_task'] = requested_task
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def wikihow_search_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('wikihow_search_query', None)

    def set_wikihow_search_query(self, wikihow_search_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['wikihow_search_query'] = wikihow_search_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def wikihow_display_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('wikihow_display_query', None)

    def set_wikihow_display_query(self, wikihow_display_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['wikihow_display_query'] = wikihow_display_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def recipe_search_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('recipe_search_query', None)

    def set_recipe_search_query(self, recipe_search_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['recipe_search_query'] = recipe_search_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def recipe_display_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('recipe_display_query', None)

    def set_recipe_display_query(self, recipe_display_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['recipe_display_query'] = recipe_display_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def query_result(self) -> List:  # List of task Maps
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('query_result', None)

    def set_query_result(self, query_result: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['query_result'] = query_result
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def dimensions_rnd_order(self) -> List:  # list of ints
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('dimensions_rnd_order', None)

    def set_dimensions_rnd_order(self, dimensions_rnd_order: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['dimensions_rnd_order'] = dimensions_rnd_order
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def confident_in_search(self) -> bool:  # current task document (json map)
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('confident_in_search', False)

    def set_confident_in_search(self, confident_in_search: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['confident_in_search'] = confident_in_search
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_task_result(self) -> map:  # current task document (json map)
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_task_result', None)

    def set_current_task_result(self, current_task_result: map = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_task_result'] = current_task_result
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_task(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_task', None)

    def set_current_task(self, current_task: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_task'] = current_task
        return self.state_manager.write_user_attributes(_user_attributes)


    """
    ### CURRENT CHOICE ###
    """
    @property
    def number_to_read(self) -> int:  # list of ints
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('number_to_read', 0)

    def set_number_to_read(self, number_to_read: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['number_to_read'] = number_to_read
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_query_result_index(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_query_result_index', 0)

    def set_current_query_result_index(self, current_query_result_index: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_query_result_index'] = current_query_result_index
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_query_method_index(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_query_method_index', 0)

    def set_current_query_method_index(self, current_query_method_index: int = 0):
        """
        Returns the updated items.
        Equivalent to current_query_result_index for wikihow methods
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_query_method_index'] = current_query_method_index
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def list_item_selected(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('list_item_selected', -1)

    def set_list_item_selected(self, list_item_selected: int = -1):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['list_item_selected'] = list_item_selected
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def is_in_suggestions(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('is_in_suggestions', False)

    def set_is_in_suggestions(self, is_in_suggestions: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['is_in_suggestions'] = is_in_suggestions
        return self.state_manager.write_user_attributes(_user_attributes)


    """
    ### CURRENT TASK STATE ###
    """
    @property
    def started_task(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('started_task', False)

    def set_started_task(self, started_task: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['started_task'] = started_task
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_recipe_recommendation(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_recipe_recommendation', None)

    def set_current_recipe_recommendation(self, current_recipe_recommendation: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_recipe_recommendation'] = current_recipe_recommendation
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def to_build(self) -> bool:  # List of task Maps
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('to_build', False)

    def set_to_build(self, to_build: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['to_build'] = to_build
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_method(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_method', 0)

    def set_current_method(self, current_method: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_method'] = current_method
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def methods_images(self) -> list:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('methods_images', None)

    def set_methods_images(self, methods_images: list = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['methods_images'] = methods_images
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_method_ingredients(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_method_ingredients', 0)

    def set_current_method_ingredients(self, current_method_ingredients: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_method_ingredients'] = current_method_ingredients
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_step(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_step', 0)

    def set_current_step(self, current_step: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_step'] = current_step
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_detail_step(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_detail_step', 0)

    def set_current_detail_step(self, current_detail_step: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_detail_step'] = current_detail_step
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_tip_step(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_tip_step', 0)

    def set_current_tip_step(self, current_tip_step: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_tip_step'] = current_tip_step
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def has_sent_card(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('has_sent_card', False)

    def set_has_sent_card(self, has_sent_card: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['has_sent_card'] = has_sent_card
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def show_ingredients(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('show_ingredients', False)

    def set_show_ingredients(self, show_ingredients: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['show_ingredients'] = show_ingredients
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def current_ingredient(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('current_ingredient', 0)

    def set_current_ingredient(self, current_ingredient: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['current_ingredient'] = current_ingredient
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def has_mentioned_timer(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('has_mentioned_timer', False)

    def set_has_mentioned_timer(self, has_mentioned_timer: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['has_mentioned_timer'] = has_mentioned_timer
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def has_mentioned_zoom(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('has_mentioned_zoom', False)

    def set_has_mentioned_zoom(self, has_mentioned_zoom: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['has_mentioned_zoom'] = has_mentioned_zoom
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def has_mentioned_video(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('has_mentioned_video', False)

    def set_has_mentioned_video(self, has_mentioned_video: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['has_mentioned_video'] = has_mentioned_video
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def said_dimensions(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('said_dimensions', None)

    def set_said_dimensions(self, said_dimensions: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['said_dimensions'] = said_dimensions
        return self.state_manager.write_user_attributes(_user_attributes)



    """
    ### PREVIOUS INTERACTION ###
    """
    @property
    def task_history(self) -> List:  # List of lists with [task_id, data_source]
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('task_history', None)

    def set_task_history(self, task_history: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['task_history'] = task_history
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def flow_states(self) -> List:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('flow_states', None)

    def set_flow_states(self, flow_states: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['flow_states'] = flow_states
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def previous_search_text(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('previous_search_text', None)

    def set_previous_search_text(self, previous_search_text: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['previous_search_text'] = previous_search_text
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def previous_data_source(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('previous_data_source', None)

    def set_previous_data_source(self, previous_data_source: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['previous_data_source'] = previous_data_source
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def previous_wikihow_search_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('previous_wikihow_search_query', None)

    def set_previous_wikihow_search_query(self, previous_wikihow_search_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['previous_wikihow_search_query'] = previous_wikihow_search_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def previous_wikihow_display_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('previous_wikihow_display_query', None)

    def set_previous_wikihow_display_query(self, previous_wikihow_display_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['previous_wikihow_display_query'] = previous_wikihow_display_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def previous_recipe_search_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('game_last_response', None)

    def set_previous_recipe_search_query(self, previous_recipe_search_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['previous_recipe_search_query'] = previous_recipe_search_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def previous_recipe_display_query(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('previous_recipe_display_query', None)

    def set_previous_recipe_display_query(self, previous_recipe_display_query: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['previous_recipe_display_query'] = previous_recipe_display_query
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def previous_task(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('previous_task', None)

    def set_previous_task(self, previous_task: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['previous_task'] = previous_task
        return self.state_manager.write_user_attributes(_user_attributes)


    """
    ### FACTS ###
    """
    @property
    def facts_per_step(self) -> List:  # list of ints
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('facts_per_step', None)

    def set_facts_per_step(self, facts_per_step: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['facts_per_step'] = facts_per_step
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def fact_to_say(self) -> map:  # map of score and text
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('fact_to_say', None)

    def set_fact_to_say(self, fact_to_say: map = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['fact_to_say'] = fact_to_say
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def has_said_fact(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('has_said_fact', False)

    def set_has_said_fact(self, has_said_fact: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['has_said_fact'] = has_said_fact
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def question(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('question', None)

    def set_question(self, question: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['question'] = question
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def task_facts(self) -> list:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('task_facts', None)

    def set_task_facts(self, task_facts: list = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['task_facts'] = task_facts
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def n_asked_facts(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('n_asked_facts', 0)

    def set_n_asked_facts(self, n_asked_facts: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['n_asked_facts'] = n_asked_facts
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def last_step_curiosity(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('last_step_curiosity', 0)

    def set_last_step_curiosity(self, last_step_curiosity: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['last_step_curiosity'] = last_step_curiosity
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def steps_said(self) -> list:
        """
        Used to keep track of the curiosities which have been said in the current step
        """
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('steps_said', None)

    def set_steps_said(self, steps_said: list = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['steps_said'] = steps_said
        return self.state_manager.write_user_attributes(_user_attributes)

    """
    ### GAME ###
    """
    @property
    def decisions(self) -> List:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('decisions', None)

    def set_decisions(self, decisions: List = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['decisions'] = decisions
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def game_over(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('game_over', False)

    def set_game_over(self, game_over: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['game_over'] = game_over
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def indirect_access(self) -> bool:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('game_over', False)

    def set_indirect_access(self, indirect_access: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['indirect_access'] = indirect_access
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def tree_choice(self) -> int:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('tree_choice', 0)

    def set_tree_choice(self, tree_choice: int = 0):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['tree_choice'] = tree_choice
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def attempting_to_leave(self) -> bool:  # list of ints
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('attempting_to_leave', False)

    def set_attempting_to_leave(self, attempting_to_leave: bool = False):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['attempting_to_leave'] = attempting_to_leave
        return self.state_manager.write_user_attributes(_user_attributes)

    @property
    def game_last_response(self) -> str:
        _user_attributes = self.state_manager.user_attributes
        return _user_attributes.get('game_last_response', None)

    def set_game_last_response(self, game_last_response: str = None):
        """
        Returns the updated items
        """
        _user_attributes = self.state_manager.user_attributes
        _user_attributes['game_last_response'] = game_last_response
        return self.state_manager.write_user_attributes(_user_attributes)

